# CROSS PLATFORM I2C DRIVER
# I2C bus access for all devices one main function for all i2c situations
# general format:
#   i2c(address,[bytes to input],number of bytes to output)
# Use:
# import iic
# i2c=IIC( -- see options-- )
# i2c.i2c(<adr>,[byets],n[,optional GC address])

from machine import I2C, Pin

# i2c univesal, slightly simpler way of handeling i2c
class IIC:
    def __init__(self,sclpin=5, sdapin=4,timeout=1000):
        self.i2cbus = I2C(-1,scl=Pin(sclpin), sda=Pin(sdapin), timeout=timeout)

    # If general call is set then that address is used for writing instead
    # of the device address, but the device address is used for reading (if any)
    def i2c(self,adr,inputv,outputn,gc=None):
        if isinstance(inputv,list):
            b = bytes(inputv)
            if gc is not None:
                self.i2cbus.writeto(gc,b)
            else:    
                self.i2cbus.writeto(adr,b)
            # do output, return a slist of values
            if outputn > 0:
                l = []
                s = self.i2cbus.readfrom(adr,outputn)
                if len(s) > 0:
                    for n in s:
                        l.append(n)
                return l 
        else:
            print('iic input must be a list')        

    def scan(self):
        return self.i2cbus.scan()
